@echo off

rem add asm80 dir to path, relative to this batch file
path %path%;%~dp0ASM80

echo Assembling main code...
cd barbie\code\main
asm80 barbie

echo Assembling SEGA loader...
cd ..\init
asm80 sega

echo Assembling graphics...
cd ..\gfx
asm80 b_gfx_1
asm80 b_gfx_2
asm80 b_gfx_3
asm80 b_gfx_4
asm80 b_gfx_5
asm80 b_gfx_6
asm80 b_gfx_7
asm80 b_gfx_8

echo Assembling OBJECTS...
cd ..\objects
asm80 objects

echo Linking...
cd ..
lnkz80 -m -c scripts\b_gfx_1.cmd > b_gfx_1.map
lnkz80 -m -c scripts\b_gfx_2.cmd > b_gfx_2.map
lnkz80 -m -c scripts\b_gfx_3.cmd > b_gfx_3.map
lnkz80 -m -c scripts\b_gfx_4.cmd > b_gfx_4.map
lnkz80 -m -c scripts\b_gfx_5.cmd > b_gfx_5.map
lnkz80 -m -c scripts\b_gfx_6.cmd > b_gfx_6.map
lnkz80 -m -c scripts\b_gfx_7.cmd > b_gfx_7.map
lnkz80 -m -c scripts\b_gfx_8.cmd > b_gfx_8.map
lnkz80 -m -c scripts\b_gfx_9.cmd > b_gfx_9.map
lnkz80 -m -c scripts\b_gfx_10.cmd > b_gfx_10.map
lnkz80 -m -c scripts\b_gfx_11.cmd > b_gfx_11.map
lnkz80 -m -c scripts\b_gfx_12.cmd > b_gfx_12.map
lnkz80 -m -c scripts\b_gfx_13.cmd > b_gfx_13.map
lnkz80 -m -c scripts\objects.cmd > objects.map
rem next does both BARBIE and SEGA
lnkz80 -m -c scripts\barbie.cmd  > barbie.map

echo Converting from Intel Hex to binary...
rem all are outputting to $8000+ so I offset
rem except: barbie outputs to $0000, offsetting makes it write a 4GB file!
if exist barbie.abs.renamed del barbie.abs.renamed
ren barbie.abs barbie.abs.renamed
for %%f in (*.ABS) do ..\..\hex2bin /O-32768 %%~nxf %%~nf.BIN >nul
rem do barbie.abs here
ren barbie.abs.renamed barbie.abs
..\..\hex2bin barbie.abs barbie.bin > nul

echo Padding files...
rem So they're 16 or 32KB each and we can concatenate them to make the ROM
for %%f in (*.bin) do ..\..\padbin 16384 %%~nxf

echo Building ROM...
copy barbie.bin ..\..\barbie-built.gg
for %%f in (b_gfx_13 b_gfx_11 b_gfx_1 b_gfx_2 objects b_gfx_3 b_gfx_4 b_gfx_5 b_gfx_6 b_gfx_7 b_gfx_8 b_gfx_9 b_gfx_10 b_gfx_12) do copy /b ..\..\barbie-built.gg+%%f.bin ..\..\barbie-built.gg > nul

cd ..\..

echo Done! Result is barbie-built.gg

:end
